
//	xsetaseta@gmail.com
//  12-Salidas-OUTPUT
//	arduLed
//	15/04/2020
//	http://seta43.blogspot.com/
//	seta43.duckdns.org
//__V.2_________

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.util.Enumeration;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.io.IOException;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import gnu.io.SerialPortEventListener;


public class arduLed extends JFrame implements SerialPortEventListener 
{
	JButton EXIT,ON,OFF,Bsend;
    static public JTextField valorOUT, valorIN;
    
    private BufferedReader bufferIN;
    private OutputStream output = null;
    SerialPort serialPort;
    private static  String PORT_NAME; // = "/dev/ttyUSB0";
    private static final int TIME_OUT = 2000;
    private static final int DATA_RATE = 9600;
    
    JCheckBox DEBUG;
    int miDebug=0;

    JRadioButton [] misBotones=new JRadioButton[20];

    public arduLed()
     {
		setLayout(new FlowLayout());
		
		JPanel p0 = new JPanel();
		p0.setLayout(new GridLayout(5, 1));
		p0.add(new JLabel("SALIDA "));
		valorOUT = new JTextField(20);
		p0.add(valorOUT);
		Bsend = new JButton("SEND");
		p0.add(Bsend);
		Bsend.addActionListener(new procesoSend());
		p0.add(new JLabel("RESPUESTA ARDUINO"));
		valorIN = new JTextField(20);
		p0.add(valorIN);
		
		JPanel p1 = new JPanel();
		p1.setLayout(new GridLayout(5, 3));
	
		for(int i=2;i<14;i++)
		{
			misBotones[i]=new JRadioButton("PIN"+i);
			p1.add(misBotones[i]);
			misBotones[i].addActionListener(new miEvento());
		}	
		
		ON= new JButton("ON");
		ON.addActionListener(new miEvento());
		ON.setActionCommand("ON");
		p1.add(ON);
		OFF= new JButton("OFF");
		OFF.addActionListener(new miEvento());
		OFF.setActionCommand("OFF");
		p1.add(OFF);		
		DEBUG= new JCheckBox("DEBUG");
		DEBUG.addActionListener(new miEvento());
		DEBUG.setActionCommand("DEBUG");
		p1.add(DEBUG);
		JPanel p3 = new JPanel();
		EXIT= new JButton("EXIT");
		EXIT.addActionListener(new miEvento());
		EXIT.setActionCommand("EXIT");
		p3.add(EXIT,BorderLayout.SOUTH);
			
		JPanel p5 = new JPanel();
		p5.setLayout(new BorderLayout());
		p5.add(p0, BorderLayout.NORTH);
		p5.add(p1, BorderLayout.WEST);

		p5.add(p3, BorderLayout.SOUTH);
		add(p5, BorderLayout.SOUTH);
		
		setSize(350, 340);
		setResizable(false);
		setMinimumSize(new Dimension(350, 340));
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		initializeArduinoConnection();
     } 
     
     class miEvento implements ActionListener 
	{
		public void actionPerformed(ActionEvent e)
		{
			String comando = e.getActionCommand();
			if(miDebug==1)System.out.println("EVENTO=" + comando);		
			for(int i=2;i<14;i++)
			{
				if (comando.equals("PIN"+i))
				{
					if(misBotones[i].isSelected()==true)						
						 sendData("SET "+i+",1\n");
						else
						 sendData("SET "+i+",0\n");
					break;
				}
			}		
			if (comando.equals("ON"))
				{				
				 for(int i=2;i<14;i++) misBotones[i].setSelected(true);
				 for(int z=2;z<14;z++)
					{sendData("SET "+ z + ",1\n");
					  try   { Thread.sleep(50);	}
					  catch (Exception h) {   System.out.println(e);	}
					}
				}
			if (comando.equals("OFF"))
				{
				 for(int i=2;i<14;i++) misBotones[i].setSelected(false);
				 for(int z=2;z<14;z++)
					{sendData("SET "+ z + ",0\n");
					  try   { Thread.sleep(50);	}
					  catch (Exception h) {   System.out.println(e);	}
					}
				}
			if (comando.equals("DEBUG"))
				{
					 if(DEBUG.isSelected()==true)						
						 miDebug=1;
						else
						 miDebug=0;
				}	
			if (comando.equals("EXIT")) { 
				//closeSerie(); 	//Si quieres que se resetee el arduino cuando se cierra la aplicación, descomenta esta linea
				System.exit(0);
				}			
		}		
	}
	
       
    public static void main(String args[]) 
		{
			if(args.length==1)
				{ PORT_NAME = args[0];	}
			 else
				{ PORT_NAME= "/dev/ttyUSB0";}
		 System.out.println("PORT_"+ PORT_NAME);

		 arduLed ventana = new arduLed();
		 System.out.println("INICIO");	
		 
		}
		


	public synchronized void serialEvent(SerialPortEvent oEvent) 
		{
			//System.out.println( "EVENTO SERIE "+ oEvent.getEventType() );
			if (oEvent.getEventType() == SerialPortEvent.DATA_AVAILABLE) 
			{
				try {
					String inputLine=bufferIN.readLine();
					if(miDebug==1)System.out.println(inputLine);
					valorIN.setText(inputLine);
					
					} 
				catch (Exception e) 
					{
					System.err.println(e.toString());
					}
			}
		}
				
    class  procesoSend  implements ActionListener 
		{
		 public void actionPerformed(ActionEvent e) 
			{
				String valor = valorOUT.getText();
				if(miDebug==1) System.out.println( "SEND=" + valor);
				sendData(valor + "\n");
			}
		}
		
	private void sendData(String data) 
		{
			try 
				{ output.write(data.getBytes()); } 
			catch(IOException e) 
				{ showError("Error sending data");	System.exit(ERROR);	}
		}
    
    private void showError(String errorMessage) 
		{ System.out.println( "ERROR " + errorMessage);  }
	
	public synchronized void closeSerie() 
		{
			if (serialPort != null) { serialPort.removeEventListener(); 	serialPort.close();	}
		}
  public void initializeArduinoConnection() 
    {
		CommPortIdentifier portId = null;
		Enumeration portEnum = CommPortIdentifier.getPortIdentifiers();
		while (portEnum.hasMoreElements()) 
			{
			CommPortIdentifier currPortId = (CommPortIdentifier)
			portEnum.nextElement();
			if (PORT_NAME.equals(currPortId.getName())) { portId = currPortId;	break;	}
		}
		if (portId == null) {
			System.out.println( "Could not find port.");
			JOptionPane.showMessageDialog(null, "Could not find port." + PORT_NAME);
			System.exit(ERROR);
			return;
		}		
		try 
			{
				serialPort = (SerialPort) portId.open(this.getClass().getName(), TIME_OUT);
				serialPort.setSerialPortParams(DATA_RATE, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
				output = serialPort.getOutputStream();
				bufferIN = new BufferedReader(new InputStreamReader(serialPort.getInputStream()));
				serialPort.addEventListener(this);
				serialPort.notifyOnDataAvailable(true);
				System.out.println( "OK port." + PORT_NAME);
			}
		catch(Exception e) 
			{
				System.out.println( "ERROR configuracion port." + PORT_NAME);
				JOptionPane.showMessageDialog(null, "ERROR configuracion port." + PORT_NAME);
				System.exit(ERROR);
			}
    }	
}
